<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Customer Group routines
'*********************************************************************************

sub refreshall
   dim sqlrs,strsql,tempstring,xcnt
   tempstring = ""
   xcnt = 0
   strsql="select groupid from groups where grouptype = 'dynamic' order by groupid"
   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   sqlrs.open strsql, dbc, adopenkeyset, adlockoptimistic
   sqlrs.movefirst
   do while not sqlrs.eof
      tempstring = tempstring & sqlrs("groupid") & ","
      xcnt = xcnt + 1
      sqlrs.movenext
   loop
   closerecordset sqlrs
   
   if xcnt > 0 then
      tempstring = mid(tempstring,1,len(tempstring)-1)
   end if
   response.write tempstring
end sub

sub refreshind (groupid,fromwhere)
   if trim(groupid) = "" then
      debugwrite getlang("langrefresherrors")
      exit sub
   end if
   
   if validgroup(groupid) = false then
      debugwrite getlang("langrefresherrors")
	  exit sub
   end if
   
   select case lcase(getgrouptype(groupid))
      case "dynamic"
	     refreshdynamic groupid,fromwhere
      case "static"
	     refreshstatic
	  case else
	     debugwrite getlang("langrefresherrors")
		 exit sub
   end select
end sub

sub refreshstatic
end sub

sub refreshdynamic (groupid,fromwhere)
   if trim(groupid) = "" then
      debugwrite getlang("langrefresherrors")
      exit sub
   end if

   dim sqlquery
   sqlquery = getsqlquery(groupid)
   if trim(sqlquery) = "" then
      debugwrite getlang("langrefresherrors")
	  exit sub
   end if

   processquery sqlquery, groupid,fromwhere
end sub

sub processquery (sqlquery,groupid,fromwhere)
   if trim(sqlquery) = "" then
      debugwrite getlang("langqueryerrors")
	  exit sub
   end if

   if trim(groupid) = "" then
      debugwrite getlang("langqueryerrors")
	  exit sub
   end if
   
   if checksqlquery(sqlquery) = false then
      debugwrite getlang("langqueryerrors")
	  exit sub
   end if
   'delete
   dim sqlrs,strsql,xcnt
   dim sqlrs2,foundflag,strsql2
   
   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   strsql = "select groupsid,contactid from customergroups where groupsid = "& groupid &""
   sqlrs.open strsql, dbc, adopenkeyset, adlockoptimistic
   if sqlrs.eof then
   else
      sqlrs.movefirst
      do while not sqlrs.eof
	     foundflag = false

	     Set sqlrs2 = Server.CreateObject("ADODB.Recordset")
		 
		 '701 - 2010.11.18 - Enhancement: Fine tune the code while "refreshing" all customer group through admin
		 dim newsqlquery, tempsqlquery
		 tempsqlquery = sqlquery
		 if instr(lcase(tempsqlquery),"order by") > 0 or instr(lcase(tempsqlquery),"group by") > 0 then
		    newsqlquery = sqlquery 
		 else
		    if instr(lcase(tempsqlquery),"where ") > 0 then
			   newsqlquery = sqlquery & " and contactid = "& sqlrs("contactid") &" "
			else
			   newsqlquery = sqlquery & " where contactid = "& sqlrs("contactid") &" "
			end if
		 end if
		 sqlrs2.open newsqlquery, dbc, adopenkeyset, adlockoptimistic
		 if sqlrs2.eof then
		 else
            foundflag = true
		 end if
		 closerecordset sqlrs2
		 
		 if foundflag = false then
		    dbc.execute ("delete from customergroups where groupsid = "& groupid &" and contactid = "& sqlrs("contactid") &"")
		 end if

	     sqlrs.movenext
		 
		 '701 - 2010.11.18 - Enhancement: Fine tune the code while "refreshing" all customer group through admin
		 response.flush
	  loop
   end if
   closerecordset sqlrs

   'add
   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   sqlrs.open sqlquery, dbc, adopenkeyset, adlockoptimistic
   if sqlrs.eof then
      '700 - 2010.05.31 - Bug Fix: SQL Query error with mysql database
	  if instr(lcase(request.ServerVariables("SCRIPT_NAME")),"shopa_addgroup.asp") <= 0 then debugwrite "0"
   else
      xcnt = 0
      sqlrs.movefirst
      do while not sqlrs.eof
	  
  	     strsql2 = "select groupsid,contactid from customergroups where groupsid = "& groupid &" and contactid = "& sqlrs("contactid") &""
	     Set sqlrs2 = Server.CreateObject("ADODB.Recordset")
		 sqlrs2.open strsql2, dbc, adopenkeyset, adlockoptimistic
		 if sqlrs2.eof then
		    'do updates
			dbc.execute ("insert into customergroups (groupsid,contactid) values("& groupid &","& sqlrs("contactid") &")")
		 else
		    'do nothing
		 end if
		 closerecordset sqlrs2

		 xcnt = xcnt + 1
	     sqlrs.movenext
		 
		 '701 - 2010.11.18 - Enhancement: Fine tune the code while "refreshing" all customer group through admin
		 response.flush
	  loop
	  if lcase(fromwhere) = "js" then
	     debugwrite xcnt
      end if
   end if
   closerecordset sqlrs
end sub

function checksqlquery (sqlquery)
   if trim(sqlquery) = "" then
      checksqlquery = false
	  exit function
   end if
   
   if lcase(mid(sqlquery,1,7)) <> "select " then
      checksqlquery = false
	  exit function
   end if

   if instr(lcase(sqlquery),"customers") <= 0 then
      checksqlquery = false
	  exit function
   end if

   if instr(lcase(sqlquery)," * ") <= 0 then
      if instr(lcase(sqlquery),"contactid") <= 0 then
	     checksqlquery = false
   	     exit function
	  end if
   end if
   
   dim sqlrs,tempflag
   on error resume next
   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   sqlrs.open sqlquery, dbc, adopenkeyset, adlockoptimistic
   
   if err.number <> 0 then
      checksqlquery = false
	  exit function
   end if

   '701 - 2012.03.13 - Enhancement: Better handling on updating customer dynamic group simultaneously
   closerecordset sqlrs
   on error goto 0

   checksqlquery = true
end function

function validgroup (groupid)
   if trim(groupid) = "" then
      validgroup = false
	  exit function
   end if

   dim sqlrs,strsql, tempflag
   strsql="select groupid from groups where groupid = "& groupid &""

   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   sqlrs.open strsql, dbc, adopenkeyset, adlockoptimistic
   if sqlrs.eof then
      tempflag = false
   else
      tempflag = true
   end if
   closerecordset sqlrs
   
   validgroup = tempflag
end function

function getgrouptype (groupid)
   if trim(groupid) = "" then
      getgrouptype = ""
	  exit function
   end if

   dim sqlrs,strsql, grouptype
   strsql="select grouptype from groups where groupid = "& groupid &""

   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   sqlrs.open strsql, dbc, adopenkeyset, adlockoptimistic
   if sqlrs.eof then
      grouptype = ""
   else
      grouptype = sqlrs("grouptype")
   end if
   closerecordset sqlrs
   
   getgrouptype = grouptype
end function

function getsqlquery (groupid)
   if trim(groupid) = "" then
      getsqlquery = ""
	  exit function
   end if

   dim sqlrs,strsql, sqlquery
   strsql="select groupsqlquery from groups where groupid = "& groupid &""

   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   sqlrs.open strsql, dbc, adopenkeyset, adlockoptimistic
   if sqlrs.eof then
      sqlquery = ""
   else
      sqlquery = sqlrs("groupsqlquery")
   end if
   closerecordset sqlrs
   
   getsqlquery = sqlquery
end function

sub refreshindfromcontact (contactid)
   if trim(contactid) = "" then
      debugwrite "Refreshing Errors"
      exit sub
   end if
   
   if validcontact(contactid) = false then
      debugwrite "Refreshing Errors"
	  exit sub
   end if
   
   'gettting group where grouptype = 'dynamic'
   dim sqlrs,strsql,tempstring
   strsql="select groupid,groupsqlquery from groups where grouptype = 'dynamic'"
   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   sqlrs.open strsql, dbc, adopenkeyset, adlockoptimistic
   do while not sqlrs.eof
      tempstring = ""
	  '701 - 2012.03.13 - Enhancement: Better handling on updating customer dynamic group simultaneously
	  if instr(lcase(sqlrs("groupsqlquery"))," where ") > 0 then
	     tempstring = mid(sqlrs("groupsqlquery"),1,instr(lcase(sqlrs("groupsqlquery"))," where ") - 1)
		 tempstring = tempstring & " where contactid = "& contactid &""
		 tempstring = tempstring & " and "
		 tempstring = tempstring & mid(sqlrs("groupsqlquery"),(instr(lcase(sqlrs("groupsqlquery"))," where ") + 7),len(sqlrs("groupsqlquery"))-(instr(lcase(sqlrs("groupsqlquery"))," where ") + 6))
	  else
	     tempstring = sqlrs("groupsqlquery") & " where contactid = "& contactid &""
	  end if
	  processquerycon tempstring,sqlrs("groupid"),contactid
	  
      sqlrs.movenext
   loop
   closerecordset sqlrs
end sub

sub processquerycon (sqlquery,groupid,contactid)
   if trim(sqlquery) = "" then
      debugwrite getlang("langqueryerrors")
	  exit sub
   end if

   if trim(groupid) = "" then
      debugwrite getlang("langqueryerrors")
	  exit sub
   end if
   
   if checksqlquery(sqlquery) = false then
      debugwrite getlang("langqueryerrors")
	  exit sub
   end if
   
   'check existence
   dim sqlrs,strsql,xcnt
   dim sqlrs2,foundflag,strsql2
   
   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   sqlrs.open sqlquery, dbc, adopenkeyset, adlockoptimistic
   if sqlrs.eof then
      dbc.execute ("delete from customergroups where groupsid = "& groupid &" and contactid = "& contactid &"")
   else
      Set sqlrs2 = Server.CreateObject("ADODB.Recordset")
	  strsql = "select groupsid,contactid from customergroups where groupsid = "& groupid &" and contactid = "& contactid &""
	  sqlrs2.open strsql, dbc, adopenkeyset, adlockoptimistic
	  if sqlrs2.eof then
	     dbc.execute ("insert into customergroups (groupsid,contactid) values ("& groupid &","& contactid &")")
	  end if
	  closerecordset sqlrs2
   end if
   closerecordset sqlrs
end sub

function validcontact (contactid)
   if trim(contactid) = "" then
      validcontact = false
	  exit function
   end if

   dim sqlrs,strsql, tempflag
   strsql="select contactid from customers where contactid = "& contactid &""

   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   sqlrs.open strsql, dbc, adopenkeyset, adlockoptimistic
   if sqlrs.eof then
      tempflag = false
   else
      tempflag = true
   end if
   closerecordset sqlrs
   
   validcontact = tempflag
end function

'700 - Customer Groups - update cusotmer group based on contactid
sub updatecustomergroup (dbtable,oldwhich,which)
   if lcase(DBTable) = "customers" then
      if getconfig("xCustomerGroupDynamicAutoAssign") = "Yes" then
         if cstr(oldwhich) <> cstr(which) then
            dim sqlrs,strsql
			if oldwhich <> "" then
               strsql="select a.contactid,a.groupsid,b.grouptype from customergroups a,groups b where a.contactid = "& oldwhich &" and a.groupsid = b.groupid and b.grouptype = 'dynamic'"
               Set sqlrs = Server.CreateObject("ADODB.Recordset")
               sqlrs.open strsql, dbc, adopenkeyset, adlockoptimistic
               do while not sqlrs.eof
                  dbc.execute ("insert into customergroups (groupsid,contactid) values ("& sqlrs("groupsid") &","& which &")")
                  sqlrs.movenext
               loop
               closerecordset sqlrs
		   	else
			   refreshindfromcontact which
			end if
         else
            'do refreshing
		    refreshindfromcontact which
         end if
      end if
   end if
end sub

'700 - Customer Groups - Generate customermatch sql
function GenerateCustomerMatchSQL (matchfield,exmatchfield,matchfield2,whereok)
   GenerateCustomerMatchSQL = ""
end function

function getgroupdiscount(contactid)
   if trim(contactid) = "" then
      getgroupdiscount = 0
      exit function
   end if
   if isnumeric(contactid) = false then
      getgroupdiscount = 0
      exit function
   end if

   dim sqlrs,strsql,tempvalue
   dim sqlrs2,strsql2
   strsql="select c.groupdiscount,c.grouppriority,c.groupid from customergroups a,customers b,groups c where (c.grouppriority <> 0 and c.grouppriority is not NULL) and a.groupsid = c.groupid and a.contactid = b.contactid and b.contactid = "& contactid &" order by c.grouptype desc, c.grouppriority asc"
   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   sqlrs.open strsql, dbc, adopenkeyset, adlockoptimistic
   if not sqlrs.eof then
      tempvalue = sqlrs("groupdiscount")
	  if isnull(tempvalue) then tempvalue = 0
   else
      strsql2="select c.groupdiscount,c.grouppriority,c.groupid from customergroups a,customers b,groups c where (c.grouppriority = 0 or c.grouppriority is NULL) and a.groupsid = c.groupid and a.contactid = b.contactid and b.contactid = "& contactid &" order by c.grouptype desc, c.groupname asc"
      Set sqlrs2 = Server.CreateObject("ADODB.Recordset")
      sqlrs2.open strsql2, dbc, adopenkeyset, adlockoptimistic
      if not sqlrs2.eof then
         tempvalue = sqlrs2("groupdiscount")
	     if isnull(tempvalue) then tempvalue = 0
      else
         tempvalue = 0
      end if
      closerecordset sqlrs2

   end if
   closerecordset sqlrs
   
   getgroupdiscount = tempvalue
end function

function getgrouppropricefield(contactid)
   if trim(contactid) = "" then
      getgrouppropricefield = ""
      exit function
   end if
   if isnumeric(contactid) = false then
      getgrouppropricefield = ""
      exit function
   end if

   dim sqlrs,strsql,tempvalue
   dim sqlrs2,strsql2
   strsql="select c.grouppropricefield,c.grouppriority from customergroups a,customers b,groups c where (c.grouppriority <> 0 and c.grouppriority is not NULL) and a.groupsid = c.groupid and a.contactid = b.contactid and b.contactid = "& contactid &" order by c.grouptype desc, c.grouppriority asc"
   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   sqlrs.open strsql, dbc, adopenkeyset, adlockoptimistic
   if not sqlrs.eof then
      tempvalue = sqlrs("grouppropricefield")
	  if isnull(tempvalue) then tempvalue = ""
   else
      strsql2="select c.grouppropricefield,c.grouppriority from customergroups a,customers b,groups c where (c.grouppriority = 0 or c.grouppriority is NULL) and a.groupsid = c.groupid and a.contactid = b.contactid and b.contactid = "& contactid &" order by c.grouptype desc, c.groupname asc"
      Set sqlrs2 = Server.CreateObject("ADODB.Recordset")
      sqlrs2.open strsql2, dbc, adopenkeyset, adlockoptimistic
      if not sqlrs2.eof then
         tempvalue = sqlrs2("grouppropricefield")
	     if isnull(tempvalue) then tempvalue = ""
      else
         tempvalue = ""
      end if
      closerecordset sqlrs2

   end if
   closerecordset sqlrs
   
   getgrouppropricefield = tempvalue
end function
%>