<%option explicit%>
<%response.buffer=true%>
<!--#include file="shop$db.asp"-->
<%ShopOpenDatabase dbc%>
<!--#include file="shopreadfile.asp"-->
<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Display shop categories
' displays a list of categories from Shopping Database
'*********************************************************************************

dim colcount, ycatmaxcolumns, totalcolumncount
dim strcatImage
dim lngcatid
dim strcathide
dim Mylink
dim highercategoryid
dim strcatmemo, strcatextra, strcatproductTemplate

SetSess "currenturl", "shopdisplaycategories.asp"
highercategoryid = cleanchars(request("id"))
if not isnumeric(highercategoryid) then
   highercategoryid = ""
end if

'700 - 2010.07.08 - Enhancement: Always redirect to SEO link if SEO Dynamic enabled
if ucase(getconfig("xSEODynamicEnable"))="YES" and ucase(getconfig("xSEODynamicProductsEnable")) = "YES" and instr(lcase(request.servervariables("SCRIPT_NAME")),"shopdisplaycategories.asp") > 0 then
   dim exdID
   dim friendlyURL
	
   exdID = highercategoryid
   if not isNumeric(exdID) then
      shopclosedatabase dbc
      response.end
   else
      'if no ID is provided, then do nothing and display all products like the standard shopdisplayproducts.asp
      if exdID <> "" then
         dim catRS
         dim catName
         dim catSubCategory

         Set catRS = Server.CreateObject("ADODB.Recordset")
         '700 - 2010.09.26 - Enhancement: Speed up front store performance
		 '701 - 2012.02.16 - Enhancement: Better DB handling on display categories page
         catRS.open "Select categoryid,catdescription,hassubcategory from categories where categoryid = " & exdID, dbc, adOpenStatic, adLockReadOnly
         if not catRS.eof then
            catName = catRS("catdescription")
            catSubCategory = catRS("hassubcategory")
            genseocategoryproductlink friendlyURL,exdID,catName,catName,catSubCategory,"No"
            closerecordset catRS
            '301 redirection code
            Response.Status="301 Moved Permanently"
            Response.AddHeader "Location", xmysite & "/"& friendlyURL
            shopclosedatabase dbc
            response.end
         else	
            closerecordset catRS
            Response.Status="301 Moved Permanently"
            Response.AddHeader "Location",xmysite
            shopclosedatabase dbc
            response.end
         end if
      end if
   end if
end if

'700 - SEO
getseohighercategoryid highercategoryid
setsess "seohighercategoryid", ""

if highercategoryid = "" then
   highercategoryid = 0
end if

'700 - 2010.04.15 - category box enhancement
SetSess "cat_id", highercategoryid

InitializeSystem
CheckDatabaseOpen dbc
ycatmaxcolumns = clng(GetConfig("xcatmaxcolumns"))
SetupdynamicCategory dbc, highercategoryid
ShopPageHeader
CategoryHeader
ShowCategories
ShopPageTrailer
ShopCloseDatabase dbc
session("seocategoryname") = ""

'Show Categories
sub ShowCategories()
   dim rs
   dim categoryid
   colcount = 0
   totalcolumncount = 0
   SQL = "Select * from categories "
   sql = Sql & " where highercategoryid=" & highercategoryid
   if GetConfig("xproductmatch") = "Yes" then
      '6.50 - enhanced product matching
      sql = sql & " and "
      generateProductmatchsqlsubscat sql
   end if

   '700 - Customer Groups - Matching Custormer match
   sql = sql & GenerateCustomerMatchSQL ("customermatch","excustomermatch","categories.loggedin","and")
   
   Handle_SelectCategoriesByLanguage
   sql = sql & " order by " & GetConfig("xsortcategories")

   '700 - 2010.08.12 - Enhancement: To speed up display categories if using sql 2005 and above
   ShopOpenRecordSet sql, rs, 9999, 1

   while not rs.eof
      categoryid = rs("categoryid")
      strcatmemo = rs("catmemo")
      strcatextra = rs("catextra")
      lngcatid = rs("categoryid")
      strcategory = rs("catdescription")
      strsubcategory = rs("hassubcategory")
      strcatimage = rs("catimage")
      strcathide = rs("cathide")
      strcatproductTemplate = rs("catproductTemplate")
      if isnull(strcatimage) then
         strcatimage = ""
      end if
      if isnull(strsubcategory) then
         strsubcategory = ""
      end if
      if isnull(strcategory) then
         '6.09 - change to use lang variable
         'strcathide = trim(GetLang("langcommonyes"))
		 'VP-ASP 6.50.4 Bugs Fix - category hide issue
		 strcathide = ""
      else
         strcategory = TranslateLanguage(dbc, "categories", "catdescription", "categoryid", categoryid, strcategory)
      end if
      if isnull(strcatextra) then
         strcatextra = ""
      end if
      if isnull(strcatmemo) then
         strcatmemo = ""
      end if
      if GetConfig("xcategoryuseTemplate") = "Yes" then
         FormatCategoryTemplate lngcatid, strcategory, rs
      else
         FormatCategory lngcatid, strcategory
      end if
      rs.MoveNext
   wend
   if colcount> 0 then
      FillRemainingColumns
   end if
   response.write "</table>"
   CloseRecordSet rs
end sub

'Used only if Template formatting is used
sub FormatCategoryTemplate(lngcatid, strcategory, objrs)
   dim Template, rc
   '7.00 - to use unique category templates
   Template = ""
   if GetConfig("xcategoryproductTemplates") = "No" then
      template = objrs("catproductTemplate")
   end if
   if Template = "" or isnull(template) then
      Template = GetConfig("xcategorydisplayTemplate")
      if Template = "" then
         SError = GetLang("LangExdNoTemplate")
         ShopError SError
      end if
   end if

   'VP-ASP 6.50.4 Bugs Fix - category hide issue
   if strcathide <> "" or isnull(strcathide) = false then
      exit sub
   end if
   if colcount = 0 then
      response.write CatRow
   end if
   
   '700 - 2010.06.18 - Bug Fix: xmaxcartcolumns issue at shopdisplaycategories.asp with some country using comma
   htmlwrite "<td class=""ac vt"" width="""& replace((100 / yCatMaxColumns),",",".") &"%"">"
   
   ShopTemplateWrite Template, objRs, rc
   response.write CatColumnEnd
   colcount = colcount + 1
   totalcolumncount = totalcolumncount + 1
   if colcount>= yCatMaxColumns then
      response.write "</tr>"
      colcount = 0
   end if
end sub

'writes out header
sub CategoryHeader
   dim header
   if highercategoryid<>0 then
      GenerateCategoryLinks header
   else
      '6.09 - added breadcrumb / 6.50 - added config option to turn breadcrumb on/off
      if GetConfig("xbreadcrumbs") = "Yes" then
         response.write "<div class=""breadcrumb""><a href=""" & GetConfig("xhome") & """>" & GetLang("langcommonhome") & "</a>&nbsp;" & SubCatSeparator & GetLang("LangCommonCategories") & "</div>"
      end if
      htmlwrite "<h1>" & GetLang("LangCat01") & "</h1>"
   end if

   '6.50 - show category file/image if displaying sub-categories
   if highercategoryid > "" then
      ShowCategoryImage
   end if
   response.write CatTable
end sub

'formats 1 category record
sub FormatCategory (id, name)
   '6.50.4 Bugs Fix - category hide issue
   if strcathide <> "" or isnull(strcathide) = false then
      exit sub
   end if
   if colcount = 0 then
      response.write CatRow
   end if
   htmlwrite "<td class=""ac vt"" width="""& (100 / yCatMaxColumns) &"%"">"
   dim mylink
   if strSubcategory = "" then
      mylink = "<a href=""shopdisplayproducts.asp?id=" & id & "&amp;cat=" & Server.URLEncode(name) & addwebsesslink & """>" & name & "</a>"
      '700 - SEO
      genseocategoryproductlink mylink,id,name,name,strSubcategory,"Yes"
	  htmlwrite mylink
   else
      response.write "<a href=""shopdisplaycategories.asp?id=" & id & "&amp;cat=" & Server.URLEncode(name) & addwebsesslink & """>" & name & "...</a>"
      if GetConfig("Xcategoryproductsonly") = "No" then
         response.write "<br />"
         response.write "<a href=""shopdisplayproducts.asp?id=" & id & "&amp;cat=" & Server.URLEncode(name) & addwebsesslink & """>" & GetLang("LangProductProduct") & "</a>"
         response.write "&nbsp;<a href=""shopdisplaycategories.asp?id=" & id & "&amp;cat=" & Server.URLEncode(name) & addwebsesslink & """>" & GetLang("langSubcategories") & "</a>"
      end if
   end if
   if strCatImage<> "" then
      AddImage id, name
   end if
   if strcatmemo<>"" then
      FormatCatMemo
   end if
   response.write CatColumnEnd
   colcount = colcount + 1
   totalcolumncount = totalcolumncount + 1
   if colcount>= yCatMaxColumns then
      response.write "</tr>"
      colcount = 0
   end if
end sub

'if category has image, format it
sub AddImage(id, iname)
   dim linkname
   linkname = Server.URLEncode(Iname)
   '700 - SEO
   dim mylink
   dim tempname
   tempname = Iname
   if getconfig("xSEODynamicEnable") = "Yes" and getconfig("xSEODynamicProductsEnable") = "Yes" then
      '701 - 2011.01.25 - Bug Fix: No class product_thumbnail assigned to category image
      genseocategoryproductlink mylink,id,tempname,tempname,"","No"
%>
<p class="ac"> <a href="<%=mylink%>"><img class="product_thumbnail" border="0" src="<%=StrCatImage%>" alt="<%=strcategory%>" /></a> </p>
<%
   else
   if strSubcategory = "" then
      '701 - 2011.01.25 - Bug Fix: No class product_thumbnail assigned to category image
%>
<p class="ac"> <a href="shopdisplayproducts.asp?id=<%=id%>&amp;cat=<%=linkname & addwebsesslink%>"><img class="product_thumbnail" border="0" src="<%=StrCatImage%>" alt="<%=strcategory%>" /></a> </p>
<%
   else
      '701 - 2011.01.25 - Bug Fix: No class product_thumbnail assigned to category image
%>
<p class="ac"> <a href="shopdisplaycategories.asp?id=<%=id%>&amp;cat=<%=linkname & addwebsesslink %>"><img class="product_thumbnail" border="0" src="<%=StrCatImage%>" alt="<%=strcategory%>" /></a> </p>
<%
   end if
   end if
end sub

sub FillRemainingColumns
   if totalcolumncount< ycatmaxcolumns then
      response.write "</tr>"
      exit sub
   end if

   do while Colcount<yCatMaxColumns
      response.write "<td>&nbsp;</td>"
      colcount = colcount + 1
   loop
   response.write "</tr>"
end sub

sub GenerateCategoryLinks (header)
   dim highercatid, cats(10), catids(10), i, mylink, categoryid
   dim cathead, more, catsql, rs
   dim id, name
   
   '701 - 2011.05.18 - Bug Fix: Category name is displaying incorrectly as the title when seo dynamic activated
   dim disname
   
   cathead = ""
   More = true
   i = 0
   highercatid = highercategoryid
   do while more = true
      catsql = "select * from categories where categoryid=" & highercatid
      Set rs = Server.CreateObject("ADODB.Recordset")
      '700 - 2010.09.26 - Enhancement: Speed up front store performance
	  '701 - 2011.03.15 - Enhancement: Speed up store performance
	  '701 - 2012.02.16 - Enhancement: Better DB handling on display categories page
      rs.open catsql, dbc, adOpenStatic, adLockReadOnly
      if not rs.eof then
         highercatid = rs("highercategoryid")
         categoryid = rs("categoryid")
         name = rs("catdescription")
         id = rs("categoryid")
         name = TranslateLanguage(dbc, "categories", "catdescription", "categoryid", categoryid, name)
		 
		 '701 - 2011.05.18 - Bug Fix: Category name is displaying incorrectly as the title when seo dynamic activated
		 '701 - 2011.06.17 - Bug Fix: Category name is displaying incorrectly while having sub-categories
		 if cstr(highercategoryid) = cstr(categoryid) then disname = name
		 
		 '701 - 2011.05.12 - Bug Fix: Higher category link breadcrumb is not formatted correctly if seo dynamic activated
         mylink = "<a href=""shopdisplaycategories.asp?id=" & categoryid & "&amp;cat=" & Server.URLEncode(name) & """>" & name & "</a>"
         genseocategoryproductlink mylink,rs("categoryid"),name,name,"","Yes"

         cats(i) = mylink
         i = i + 1
         if highercatid = 0 then
            more = false
         end if
      else
         more = false
      end if
      CloseRecordSet rs
   loop

   '6.09 - added home to breadcrumb
   mylink = "<a href=""" & GetConfig("xhome") & """>" & GetLang("langcommonhome") & "</a>&nbsp;" & SubCatSeparator & "<a href=""shopdisplaycategories.asp"">" & GetLang("LangCommonCategories") & "</a>"
   cats(i) = mylink
   i = i + 1
   for i = 0 to i -1
      if cathead = "" then
         cathead = cats(i)
      else
         cathead = cats(i) & subcatseparator & cathead
      end if
   next
   header = cathead
   SetSess "breadcrumb", cathead

   '6.50 - added config option to turn breadcrumb on/off
   if GetConfig("xbreadcrumbs") = "Yes" then
      htmlwrite "<div class=""breadcrumb"">" & header & "</div>"
   end if
   
   '701 - 2011.05.18 - Bug Fix: Category name is displaying incorrectly as the title when seo dynamic activated
   htmlwrite "<h1>" & disname & "</h1>"
end sub

sub Handle_Product (isub)
   select case isub
      case "FORMATIMAGE"
         if strCatImage<> "" then
            AddImage lngcatid, strcategory
         end if
      case "FORMATHYPERLINKS"
         GenerateCatLink lngcatid, strcategory
      case "ADDNUMBERSUBCATS"
         Handle_NumberSubCats lngcatid, "", ""
      case else
         DebugWrite "Unknown sub"
   end select
end sub

sub GenerateCatLink(id, name)
   dim mylink
   if strSubcategory = "" then
      mylink = "<a href=""shopdisplayproducts.asp?id=" & id & "&amp;cat=" & Server.URLEncode(name) & Addwebsesslink & """>" & name & "</a>"
      '700 - SEO
      genseocategoryproductlink mylink,id,name,name,strSubcategory,"Yes"
	  htmlwrite mylink
   else
      mylink = "<a href=""shopdisplaycategories.asp?id=" & id & "&amp;cat=" & Server.URLEncode(name) & addwebsesslink & """>" & name & "...</a>"
      '700 - SEO
      genseocategoryproductlink mylink,id,name,name,strSubcategory,"Yes"
	  htmlwrite mylink
      if GetConfig("Xcategoryproductsonly") = "No" then
         htmlwrite "<br />"
         '700 - SEO
	     'if getconfig("xSEODynamicEnable") = "Yes" then
		 '   genseocategoryproductlink mylink,id,name,GetLang("LangProductProduct"),strSubcategory,"Yes"
		'	htmlwrite mylink
		'    genseocategoryproductlink mylink,id,name,GetLang("langSubcategories"),strSubcategory,"Yes"
		'	htmlwrite mylink
		 'else
            mylink = "<a href=""shopdisplayproducts.asp?id=" & id & "&amp;cat=" & Server.URLEncode(name) & addwebsesslink & """>" & GetLang("LangProductProduct") & "</a>"
            mylink = mylink & "&nbsp;<a href=""shopdisplaycategories.asp?id=" & id & "&amp;cat=" & Server.URLEncode(name) & addwebsesslink & """>" & GetLang("langSubcategories") & "</a>"
  		    htmlwrite mylink
		 'end if
      end if
   end if
end sub

sub FormatCatMemo
   if GetConfig("xcategorydisplaytext") = "Yes" then
      if strcatmemo<>"" then
         response.write catmemostart & strcatmemo & catmemoend
      end if
   end if
end sub

sub Handle_SelectCategoriesByLanguage
   if GetConfig("xselectproductsbylanguage") = "Yes" and GetSess("language")<>"" then
      sql = sql & " and (catlanguage='" & GetSess("language") & "'"
      sql = sql & " or catlanguage is null)"
   end if
end sub

'6.5  - show category image or file at the top of subcat display
sub ShowCategoryImage
   dim ImageFileName, description, i
   dim rs
   dim query
   imagefilename = ""
   if highercategoryid = "" then exit sub
   if GetConfig("xDisplayCategoryImages") = "Yes" or GetConfig("xdisplaycategoryfiles") = "Yes" then
      query = "select * from categories where categoryid = " & highercategoryid
      Set rs = Server.CreateObject("ADODB.Recordset")
      '700 - 2010.09.26 - Enhancement: Speed up front store performance
	  '701 - 2011.03.15 - Enhancement: Speed up store performance
	  '701 - 2012.02.16 - Enhancement: Better DB handling on display categories page
      rs.open query, dbc, adOpenStatic, adLockReadOnly
      if not rs.eof then
         imagefilename = rs("catimage")
         description = rs("catextra")
         if isnull(imagefilename) then
            imagefilename = ""
         end if
         if isnull(description) then
            description = ""
         end if
      end if
      CloseRecordSet rs
   else
      exit sub
   end if

   if GetConfig("xDisplayCategoryImages") = "Yes" and imagefilename<>"" then
      '701 - 2011.01.25 - Bug Fix: No class product_thumbnail assigned to category image
      htmlwrite "<p class=""ac""><img class=""product_thumbnail"" border=""0"" src=""" & ImageFileName & """ alt="" "" /></p>"
   end if

   if GetConfig("xdisplaycategoryfiles") = "Yes" and description <>"" then
      dim readarray(500), readcount
      readcount = 0
      ShopReadFile description, ReadArray, readcount
      if readcount = 0 then exit sub
      htmlwrite "<br />"
      for i = 0 to readcount -1
         htmlwrite readarray(i) & vbcrlf
      next
   end if
end sub
%>