<%option explicit%>
<%response.buffer=true%>
<!-- #include file="admin$db.asp" -->
<%ShopOpenDatabase dbc%>
<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Close a gateway order when customer did not return to our site
'*********************************************************************************

ShopCheckAdmin "shopa_displayorders.asp"

dim ptype, oid, followon, here, orderid, ordernumber, deeddone
SError = ""

'701- 2010.11.25 - Bug Fix: http and https is not sharing session and causing finalize order not working
here = genredirecturl ("/shopa_formatorder.asp?oid=" & oid)

deeddone = CleanChars(request("pass"))
oid = CleanChars(request("oid"))

'700 - Product Matching Enhancement
if getconfig("xproductmatch") = "Yes" then
   if ucase(GetSess("Admintype")) <> "SUPER" then
      dim storematch
	  storematch = getstorematch (oid)
	  
	  '700 - 2010.06.10 - Enhancement: Recode storematch condition at shopa_closeorder.asp
	  if isnull(storematch) = false then
	     if trim(storematch) <> "" then
		    if lcase(storematch) <> lcase(xShopId) then
			   ShopError GetLang("LangAdminUnauth")
			end if
		 end if
	  end if

   end if
end if

if deeddone = "" then
   adminpageheader
   showform
   adminpagetrailer
elseif deeddone<>2 then
   '700 - 2010.04.22 - cross site script security enhancement
   verifygenpredefinedsecuritycode request("genpredefinedsecuritycode")

   ValidateData() 'will set ptype to current ocardtype value
   UpdatePaymentType
   if SError <> "" then 'bad order data, rewrite form
      AdminPageHeader ' Write admin header
      showform
      AdminPageTrailer ' Write admin trailer
   else
      if isnull(ptype) then
         ptype = "PayPal"
      end if
      SetSess "oid", oid
      UpdatePaymentInfo ptype
      SetSess "fromadminscript", "shopa_closeorder.asp"

      '701- 2010.11.25 - Bug Fix: http and https is not sharing session and causing finalize order not working
	  followon = genredirecturl ("/shopthanks2.asp?oid=" & oid)

      ResponseRedirect followon
   end if
else 'the deed was done
   '700 - 2010.04.22 - cross site script security enhancement
   verifygenpredefinedsecuritycode request("genpredefinedsecuritycode")

   SError = "Order " & oid & " was closed"
   AdminPageHeader ' Write admin header
   showform
   AdminPageTrailer ' Write admin trailer
end if
ShopCloseDatabase dbc

' make sure we have a valid order number
sub ValidateData
   dim rc
   orderid = oid
   ordernumber = orderid
   if orderid<>"" then
      if not isnumeric(orderid) then
         SError = GetLang("LangStatuSError01") & "<br />"
      else
         CheckexistingOrder rc 'make sure it's in the orders table
         if rc = 3 then 'already processed
            SError = GetLang("langShopThanks03") & " " & ordernumber 'report error
         end if
         if rc = 4 then 'not in order table
            SError = GetLang("LangFormatNone") & " " & ordernumber 'report error
         end if
      end if
   else
      SError = GetLang("LangStatusOrderNumber") & " " & GetLang("langcustrequired")
   end if
end sub

sub DisplayErrors
   if SError<> "" then
      ShopWriteError SError
      SError = ""
   end if
end sub

sub showform 'create a form to enter order number
%>
<table width="100%">
  <tr>
    <td align="left"><%ShopWriteHeader "Finalize Order"%></td>
    <%if oid > "" then%>
    <td align="right"><a href='shopa_formatorder.asp?oid=<%=oid%>'><img src="images/admin/main/arrow_left_blue.gif" border="0"><br />
      Back To Order</a></td>
    <%else%>
    <td align="right"><a href='shopa_displayorders.asp'><img src="images/admin/main/arrow_left_blue.gif" border="0"><br />
      Order List</a></td>
    <%end if%>
  </tr>
</table>
<br />
<%
   DisplayErrors
   GenerateDisplayHeader "Finalize Order"
   GenerateDisplayBodyHeader
%>
<form action="shopa_closeorder.asp" method="POST">
<%
'700 - 2010.04.22 - cross site script security enhancement
htmlwrite "<input type=""hidden"" name=""genpredefinedsecuritycode"" value="""& session("genpredefinedsecuritycode") &""" />"
%>
<table>
  <tr>
    <%'700 - 2010.08.10 - Enhancment: Update language reference%>
    <td><strong><%=getlang("langdownloadorderid")%>:</strong></td>
    <td><input type='text' name='oid' value='<%=oid%>' size=10 maxlength=10></td>
  </tr>
  <tr>
    <%
   dim validtypes, ii
   if GetConfig("xendofordervalidpayments") > "" then
      HtmlWrite "<td><strong>Payment Type: </strong></td>"
      HtmlWrite "<td><select name='ocardtype'><option>- Select -</option>"
      if instr(GetConfig("xendofordervalidpayments"), ",") > 0 then
         validtypes = split(GetConfig("xendofordervalidpayments"), ",")
         for ii = 0 to ubound(validtypes)
            HtmlWrite "<option value='" & validtypes(ii) & "'>" & validtypes(ii) & "</option>"
         next
      else
         HtmlWrite "<option value='" & GetConfig("xendofordervalidpayments") & "'>" & GetConfig("xendofordervalidpayments") & "</option>"
      end if
      HtmlWrite "</select> *This will change the Payment Type in the Order Record. Don't select a value if you don't want to change this.</td>"
   else
      HtmlWrite "<td colspan=""2"">You have no entries in your xendofordervalidpayments - if you want to select a payment type for this order, you must enter the names of your valid payments in the xendofordervalidpayments configuration option first.</td>"
   end if
%>
  </tr>
</table>
<%
   HtmlWrite "<input type=""hidden"" name=""pass"" value=""1"">"
   HtmlWrite "<BR><INPUT TYPE='submit' NAME='submitName'  VALUE='Submit'></FORM></P>"
   GenerateDisplayBodyFooter
end sub

sub UpdatePaymentInfo (paymenttype) 'set order field ocardtype to paymenttype
   dim sqltemp
   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   sqltemp = "update orders set ocardtype="& sqlserverprefixn &"'" & paymenttype &"'" & " where orderid=" & oid
   dbc.execute(sqltemp)
end sub

' Make sure order exists and oprocessed is not true
' if yes rc=0 else if not present rc=4 else if processed rc=3
sub CheckexistingOrder (rc)
   dim rs, sql
   sql = "select * from orders where orderid=" & ordernumber
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sql, dbc, adOpenDynamic, adLockOptimistic
   if rs.eof then 'does not exist
      rc = 4
   else
      if ucase(rs("oprocessed")) = "TRUE" then 'order has been processed
         rc = 3
      else
         rc = 0
      end if
   end if
   'get current value for ocardtype
   ptype = rs("ocardtype")
   rs.close
   set rs = nothing
end sub

sub UpdatePaymentType
   if request.form("ocardtype") > "" then
      ptype = request.form("ocardtype")
	  '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      dbc.execute("update orders set ocardtype = "& sqlserverprefixn &"'" & ptype & "' where orderid=" & ordernumber)
   end if
end sub
%>