<%option explicit%>
<%response.buffer=true%>
<!--#include file="admin$db.asp"-->
<%ShopOpenDatabase dbc%>
<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Edits translate tables
'*********************************************************************************

ShopCheckAdmin ""
dim Addaction, Updateaction, Deleteaction
dim rstemp
dim which
dim IDField
dim DBTable
dim translatetable
dim languages, langcount, url
dim strlanguage, CatalogId
dim helpfile
helpfile = "shopa_producthelp.htm"
Addaction = Request.form("add")
Updateaction = Request.form("update")
SError = ""
Deleteaction = request("delete")
GetInputValues
if DeleteAction<>"" then
   '700 - 2010.04.22 - cross site script security enhancement
   verifygenpredefinedsecuritycode request("genpredefinedsecuritycode")

   DeleteRecord
end if
if Addaction = "" and Updateaction = "" then
   AdminPageHeader
   SetDefaultvalues
   GenerateForm
   AdminPageTrailer
else
   '700 - 2010.04.22 - cross site script security enhancement
   verifygenpredefinedsecuritycode request("genpredefinedsecuritycode")

   AdminPageHeader
   UpdateRecord
   GenerateForm
   AdminPageTrailer
end if
ShopCloseDatabase dbc

sub GetInputValues
   ' ID, allows editing a record
   which = request.querystring("which")

   '6.09 - Precautionary Security Fix
   if which > "" then
      if not isnumeric(which) then
         ShopError "ID must be numeric"
      end if
   end if

   IDField = request.querystring("IDField")
   DBTable = request.querystring("table")
   url = request("url")
   if url = "" then
      url = GetSess("currenturl")
   end if
   ValidateTable
   dim force
   force = "Yes"
   GetLanguages languages, langcount, force
   DebugWrite "languagecount=" & langcount
end sub

sub ValidateTable
   'See if user has access to this table
   dim UserTables, i
   dim tablecount
   if GetConfig("XRestrictAdminTables")<>"Yes" then exit sub
   UserTables = GetSess("UserTables")
   if isnull(UserTables) then
      exit sub
   end if
   if UserTables = "" then
      exit sub
   else
      UserTables = split(GetSess("UserTables"), ",", -1, 1)
   end if
   tablecount = ubound(UserTables)
   for i = 0 to tablecount
      if ucase(DBTable) = ucase(Usertables(i)) then
         exit sub
      end if
   next
   DBTable = ""
end sub

' Get the specific record and then generate form based on this record
sub GenerateForm
   dim sqltemp
   if which <> "" then
      sqltemp = "select * from " & DBTable
      sqltemp = sqltemp & " where " & IDField & "=" & which
      DebugWrite sqltemp
      Set rstemp = Server.CreateObject("ADODB.Recordset")

      '701 - 2011.12.07 - Enhancement: Speed up admin pages
      rstemp.open sqltemp, dbc, adOpenStatic, adLockReadOnly
   end if
   DisplayForm
   if which <> "" then
      rstemp.close
      set rstemp = nothing
   end if
end sub

sub DisplayForm()
   if which <> "" then
      memcdescription = rstemp("cdescription")
      strlanguage = rstemp("lang")
      CatalogId = rstemp("CatalogId")
      strcname = rstemp("cname")
      memexdesc = rstemp("extendeddesc")
   end if
   htmlwrite "<form name=""editform"" action=""shopa_edittranslate.asp?which=" & which & "&IDField=" & IDField & "&table=" & DBTable &""" method=""POST"">"

   '700 - 2010.04.22 - cross site script security enhancement
   htmlwrite "<input type=""hidden"" name=""genpredefinedsecuritycode"" value="""& session("genpredefinedsecuritycode") &""" />"

   '600 - ADD HTML EDITOR
   AddEditor "editform"
   ShopWriteHeader GetLang("LangEdit02")
   ShopWriteError SError
   htmlwrite "<a href='shopa_editrecord.asp?which=" & which & "&table=" & DBTable & "&IDField=" & IDField &"'>" & GetLang("LangCommonEdit") & "</a>&nbsp;&nbsp;"
   htmlwrite "<a href='shopa_editdisplay.asp?table=" & DBTable &"'>" & GetLang("LangEditSelectSetup") & "</a>"

   '6.50 - Added buttons to top of page as well as bottom
   htmlwrite "<center>"
   if which<>"" then
      htmlwrite "&nbsp;&nbsp;<input class=""submitbtn"" type=submit name=Update value='" & GetLang("LangEditUpdateRecord") & "'>&nbsp;&nbsp;"
      htmlwrite "<input class=""submitbtn"" type=submit name=add value='" & GetLang("LangEditCopy") & "'>"
	  '700 - 2010.06.18 - Enhancement: Delete record notification
      htmlwrite "&nbsp;&nbsp;<input class=""submitbtn"" onclick='return doDeleteWarning()' type=submit name=Delete value='" & GetLang("LangCommonDelete") & "'>"
      htmlwrite "</p>"
   else
      htmlwrite "<input class=""submitbtn"" type=submit name=add value='" & GetLang("LangEditAdd") & "'>"
   end if
   htmlwrite "</center>"
   htmlwrite TableDef
   htmlwrite tablerow & tablecolumn & GetLang("LangLanguage") & tablecolumnend & tablecolumn
   GenerateSelectNV languages, strlanguage, "lang", langcount, GetLang("Langcommonselect")
   htmlwrite Tablecolumnend & TableRowEnd
   formateditrow "CatalogId", "CatalogId", CatalogId, ""
   PCreateRowText GetLang("LangProductName"), "cname", strCname, 1, ""
   PCreateRowText GetLang("LangProductDescription"), "cdescription", memcdescription, 3, "cdescription"
   PCreateRowText GetLang("LangProductEXtendedDescription"), "extendeddesc", memexdesc, 3, "extendeddesc"
   htmlwrite TableDefEnd
   if which<>"" then
      '700 - 2010.05.17 - Bug Fix: Unable to uprdate product/content/etc when using chrome or safari.
      htmlwrite "&nbsp;&nbsp;<input class=""submitbtn"" type=submit name=Update value='" & GetLang("LangEditUpdateRecord") & "'>&nbsp;&nbsp;"
      htmlwrite "<input class=""submitbtn"" type=submit name=add value='" & GetLang("LangEditCopy") & "'>"

      '6.50 - Moved Delete button to be on same line as Add and Update
	  '700 - 2010.06.18 - Enhancement: Delete record notification
      htmlwrite "&nbsp;&nbsp;<input class=""submitbtn"" onclick='return doDeleteWarning()' type=submit name=Delete value='" & GetLang("LangCommonDelete") & "'>"
      htmlwrite "</p>"
   else
      '700 - 2010.05.17 - Bug Fix: Unable to uprdate product/content/etc when using chrome or safari.
      htmlwrite "<input class=""submitbtn"" type=submit name=add value='" & GetLang("LangEditAdd") & "'>"
   end if
   htmlwrite "</form>"
end sub

sub UpdateRecord
   dim sqltemp
   '6.50 - broadened defintion of IF statement to cover cases where xmysql hasn't been set
   if instr(ucase(xdatabasetype), "MYSQL") > 0 then
      MYSQLProcessrecord updateaction, dbc, DBTable, IDField, which
      exit sub
   end if
   if updateaction<>"" then
      '701 - 2011.12.05 - Bug Fix: SQL DB: Not able to insert value to new translate record.
      'sqltemp = "select * from " & DBTable
      'sqltemp = sqltemp & " where " & IDField & "=" & which
      'set rstemp = Server.createobject("ADODB.Recordset")
      'rstemp.open sqltemp, dbc, 1, 3
      'rstemp.Update
   else
      set rstemp = Server.createobject("ADODB.Recordset")
      rstemp.open DBTable, dbc, adOpenKeyset, adLockOptimistic
      rstemp.AddNew

      '701 - 2011.12.05 - Bug Fix: SQL DB: Not able to insert value to new translate record.
	  rstemp.update
	  which = rstemp(IDField)
	  rstemp.close
	  set rstemp = nothing
   end if

   '701 - 2011.12.05 - Bug Fix: SQL DB: Not able to insert value to new translate record.
   sqltemp = "select * from " & DBTable
   sqltemp = sqltemp & " where " & IDField & "=" & which
   set rstemp = Server.createobject("ADODB.Recordset")
   rstemp.open sqltemp, dbc, adOpenKeyset, adLockOptimistic
   rstemp.Update

   GenerateUpdateSQL
   which = rstemp(IDField)
   rstemp.close
   set rstemp = nothing
   SError = SError & "<br /><b>" & GetLang("LangEdit03") & "</b>"
end sub

sub GenerateUpdateSQL()
   dim howmanyfields
   dim fieldname, fieldvalue, fieldtype
   dim i
   howmanyfields = rstemp.fields.count -1
   rstemp.update
   for i = 1 to howmanyfields
      fieldname = rstemp(i).name
      fieldtype = rstemp(i).type
      fieldvalue = request.form(fieldname)
      EUpdateField fieldname, fieldvalue
   next
   rstemp.update
end sub

sub EUpdateField (fieldname, fieldvalue)
   on error resume next
   DebugWrite fieldname & "value=" & fieldvalue
   if fieldvalue = "" then
      rstemp(Fieldname) = NULL
      exit sub
   end if

   if ucase(fieldvalue) = "NULL" then
      rstemp(Fieldname) = NULL
   else
      rstemp(Fieldname) = fieldvalue
   end if
end sub

' Find the first record so rest of code works
sub SetDefaultvalues
   dim sql, rs
   if which<>"" then exit sub
   sql = "select * from translateproducts"
   Set rs = Server.CreateObject("ADODB.Recordset")

   '701 - 2011.12.07 - Enhancement: Speed up admin pages
   rs.open sql, dbc, adOpenStatic, adLockReadOnly

   which = rs(0)
   CloseRecordSet rs
end sub

sub DeleteRecord
   dim sql, url
   sql = "delete from " & DBTable & " where " & IDField & "=" & which
   dbc.execute(sql)
   url = "shopa_editdisplay.asp?table=" & DBTable
   ResponseRedirect url
end sub

' New to find which table and which record
sub GetFormFields
end sub

sub GetExistingProduct
   dim rs, sql
   sql = "Select " & realname & " from " & table & " where " & IDField & "=" & recordid
   DebugWrite sql
   response.flush
   Set rs = Server.CreateObject("ADODB.Recordset")

   '701 - 2011.12.07 - Enhancement: Speed up admin pages
   rs.open sql, dbc, adOpenStatic, adLockReadOnly

   if not rs.eof then
      textdata = rs(realname)
   end if
   CloseRecordSet rs
end sub

sub PCreateRowText (caption, fieldname, fieldvalue, rows, realname)
   dim url, htmlurl, linkurl
   url = "shopa_edittranslate.asp?which=" & which
   htmlurl = "shopa_htmledit.asp?which=" & which & "&IDField=CatalogId&table=products&fieldname=" & realname
   htmlurl = htmlurl & "&url=" & server.urlencode(url)
   Linkurl = "<a href='" & htmlurl & "'>" & "HTML edit" & "</a>"
   response.write tablerow & tablecolumn & caption
   response.write tablecolumnend
   response.write "<td>"'<Textarea rows=" & rows & " cols=40  name='" & fieldname & "'>" & fieldvalue & "</textarea>"
      response.write "<Textarea rows=" & rows & " cols=40  name='" & fieldname & "'>" & fieldvalue & "</textarea>"
   response.write "</td>"
   FormatEditHelp fieldname, helpfile
   response.write "</tr>"
end sub

' Get languages from language file or array
' Do not include default laqnguage
sub GetLanguages (languages, langcount, force)
   dim cid, name, catSQL, i, defaultlang
   dim maxlangs, catrs, mylink
   langcount = 0
   maxlangs = 20
   defaultlang = lcase(GetConfig("xlanguage"))
   redim languages(maxlangs)
   catSQL = "SELECT lang from languages GROUP BY lang"
   Set catrs = Server.CreateObject("ADODB.Recordset")

   '701 - 2011.12.07 - Enhancement: Speed up admin pages
   catrs.open catsql, dbc, adOpenStatic, adLockReadOnly

   do while not catrs.eof and langcount<maxlangs
      name = catrs("lang")
      if lcase(name)<>defaultlang then
         languages(langcount) = name
         langcount = langcount + 1
      end if
      catrs.MoveNext
   loop
   CloseRecordSet catrs
end sub
%>